<?php defined('SYSPATH') OR die('No direct access allowed.');
class Admin_users_Controller extends website_Controller {

	const ALLOW_PRODUCTION = FALSE;
	public $template = 'admin_template/template';
	public function __construct()
	{
		parent::__construct();
		if((!$this->user_id || $this->user_type != 1) && $this->uri->last_segment() != "admin-login.html"){
			url::redirect(PATH);
		} 
		include Kohana::find_file('language', "admin_users_".LANGUAGE);
		$cont1 = $content_text; 
		
		$this->Lang = array_merge($cont1, $this->Lang);
		
		$this->users = new Admin_users_Model();	
		$this->users_act = "1";	
	}
	
	/** ADD USERS **/
	
	public function add_users()
	{
		$this->add_users = "1";
        
			if($_POST){
				$this->userPost = $this->input->post();
				$post = new Validation($_POST);
				$post = Validation::factory($_POST)
							->add_rules('firstname', 'required', 'chars[a-zA-Z0-9 _-]')
							->add_rules('lastname', 'required', 'chars[a-zA-Z0-9 _-]')
							->add_rules('email', 'required','valid::email', array($this, 'email_available'))
							->add_rules('mobile', 'required', array($this, 'validphone'), 'chars[0-9-+(). ]')
							->add_rules('address1', 'required')
							->add_rules('country', 'required')
							->add_rules('city', 'required');
				if($post->validate()){
					$referral_id = text::random($type = 'alnum', $length = 8);
					$status = $this->users->add_user(arr::to_object($this->userPost),$referral_id);
						if($status == 1){
							common::message(1, $this->Lang["USER_ADD_SUC"]);
							url::redirect(PATH."admin/manage-user.html");
						}
				}
				else{
					$this->form_error = error::_error($post->errors());	
				}
			}
		$this->country_list = $this->users->getcountrylist();
		$this->city_list = $this->users->getCityList();
		$this->template->title = $this->Lang["ADD_USER"];
		$this->template->content = new View("add_users");
	}
	
	/** Manage Users **/
	
	public function manage_users($page = "")
	{   
		$this->manage_users = "1";
		
		if($_POST){
			$post = Validation::factory($_POST)->pre_filter('trim')->add_rules('message', 'required');		
				if($post->validate()){

				$email_id = $this->input->post('email');
				$message = $this->input->post('message');
				$fromEmail = NOREPLY_EMAIL;
				if(EMAIL_TYPE==2){
				email::smtp($fromEmail,$email_id, SITENAME, $message);
				}
			   	else{
				email::sendgrid($fromEmail,$email_id, SITENAME, $message);
				}
				common::message(1, $this->Lang["MAIL_SENDED"]);
				url::redirect(PATH."admin/manage-user.html");
			}
			else{	
				$this->form_error = error::_error($post->errors());
			}
		}
		$this->type = $this->input->get('sort');
		$this->sort = $this->input->get('param');
		$this->sort_url= PATH.'admin/manage-user.html?';
		$this->count_user = $this->users->get_users_count($this->input->get('name'), $this->input->get('email'), $this->input->get('city'), $this->input->get('logintype'),$this->type,$this->sort);

 

        $this->pagination = new Pagination(array(
            'base_url'       => 'admin/manage-user.html/page/'.$page."/",
            'uri_segment'    => 4,
            'total_items'    => $this->count_user,
            'items_per_page' => 10, 
            'style'          => 'digg',
            'auto_hide'      => TRUE
        ));
        $search = $this->input->get('id'); 
        $this->search = $this->input->get(); 
        $this->search_key = arr::to_object($this->search); 
        $this->users_list = $this->users->get_users_list($this->pagination->sql_offset, $this->pagination->items_per_page, $this->input->get('name'), $this->input->get('email'), $this->input->get('city'), $this->input->get('logintype'),$this->type,$this->sort);

        $this->city_list = $this->users->getCityListOnly();		
			if($search){
						$out = $this->Lang["S_NO"].',"'.$this->Lang["FIRST_NAME"].'","'.$this->Lang["LAST_NAME"].'","'.$this->Lang["EMAIL"].'","'.$this->Lang["PH_NUM"].'","'.$this->Lang["ADDR1"].'","'.$this->Lang["ADDR2"].'","'.$this->Lang["COUNTRY"].'","'.$this->Lang["CITY"].'","'.$this->Lang["REFERAL_AMMOUNT_ERN"].'","'.$this->Lang["JOIN_DATE"].'"'."\r\n";	
					$i = 1;
				foreach($this->users_list as $d)
				{
					$out .= $i.',"'.$d->firstname.'","'.$d->lastname.'","'.$d->email.'","'.$d->phone_number.'","'.$d->address1.'","'.$d->address2.'","'.$d->country_name.'","'.$d->city_name.'","'.(CURRENCY_SYMBOL.$d->user_referral_balance).'","'.date('d-M-Y h:m:i a',$d->joined_date).'"'."\r\n";
					$i++;					
				}
					header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
					header("Content-Length: " . strlen($out));
					header("Content-type: application/csv");
					header("Content-type: application/octet-stream");
					header("Content-Disposition: attachment; filename=Users.csv");
					echo $out; 
					exit;
			}	
                $this->template->title = $this->Lang["MANAGE_USER"];
                $this->template->content = new View("manage_users");
	}
	
	/** UPDATE USER DETAILS **/	
	
	public function edit_users($userid = "")
	{ 
		$this->manage_users = "1";
		if($_POST){
			$this->userpost = $this->input->post();
			$post = new Validation($_POST);			
			$post = Validation::factory($_POST)
						->add_rules('firstname', 'required', 'chars[a-zA-Z0-9 _-]')
						//->add_rules('lastname','required','chars[a-zA-Z0-9 _-]')
						->add_rules('email', 'required','valid::email')
						->add_rules('mobile', array($this, 'validphone'), 'chars[0-9-+(). ]')
						->add_rules('country', 'required')
						->add_rules('city', 'required');
			if($post->validate()){			
				$status = $this->users->edit_users($userid, arr::to_object($this->userpost));
				if($status ==1){
					common::message(1, $this->Lang["USER_EDIT_SUC"]);
					url::redirect(PATH.'admin/manage-user.html');
				}
				elseif($status == 2 ){
					$this->form_error["email"] = $this->Lang["EMAIL_AL_E"];
				} 
			}
			else{
				$this->form_error = error::_error($post->errors());
			}
		}		
		$this->city_list = $this->users->getCityList();
		$this->country_list = $this->users->getcountrylist();
		$this->user_data = $this->users->get_users_data($userid);	
		if(count($this->user_data) == 0){
			common::message(-1, $this->Lang["NO_RECORD_FOUND_USER"]);
			url::redirect(PATH."admin/manage-user.html");
		}
		$this->template->title = $this->Lang["EDIT_USER"];
		$this->template->content = new View("edit_users");
	}
	
	/** BLOCK AND UNBLOCK USER **/
	
	public function block_user($type = "", $email="", $uid = "")
	{
	    $email = base64_decode($email);
		$status = $this->users->blockunblockuser($type, $uid, $email);
		if($status == 1){
			if($type == 1){
				common::message(1, $this->Lang["USER_UNB"]);
			}
			else{
				common::message(1, $this->Lang["USER_B"]);
			}
		}
		else{
			common::message(-1, $this->Lang["NO_RECORD_FOUND"]);
		}
		url::redirect(PATH."admin/manage-user.html");
	}
	
	/** DELETE USER **/
	
	public function delete_user($uid = "", $email = "")
	{
	    $email =  base64_decode($email); 
		if($uid){
			$status = $this->users->deleteuser($uid, $email);
			if($status == 1){
				common::message(1, $this->Lang["USER_DEL_SUC"]);
			}
			else{
				common::message(-1, $this->Lang["NO_RECORD_FOUND"]);
			}
		}
		url::redirect(PATH."admin/manage-user.html");
	}
	
	/** CHECK PASSWORD EXIST **/
	 
	public function check_password($password = "")
	{
		$exist = $this->users->exist_password($password, $this->user_id);
		return $exist;
	}
	
	/** CHECK EMAIL EXIST **/
	 
	public function email_available($email)
	{
		$exist = $this->users->exist_email($email);
		return ! $exist;
	}
	
	/** CHECK VALID PHONE OR NOT **/
	
	public function validphone($phone = "")
	{
		if(valid::phone($phone,array(7,10,11,12,13,14)) == TRUE){
			return 1;
		}
		return 0;
	}
	
	/** COUNTRY BASED CITY SELECT**/
	
	public function CityS($country)
	{

		if($country == -1){
			$list = '<td><label>'.$this->Lang["SEL_CITY"].'</label></td><td><label>:</label></td><td><select name="city">';
			$list .='<option value=" " >'.$this->Lang["CITY_FIRST"].'</option>';
			echo $list .='</select></td>';
		exit;
		}
		else{		
		        $CitySlist = $this->users->get_city_by_country($country);
		        if(count($CitySlist) == 0){
		                $list = '<td><label>'.$this->Lang["SEL_CITY"].'</label></td><td><label>:</label></td><td><select name="city">';
			        $list .='<option value="" >'.$this->Lang["NO_CITY_CRTY"].'</option>';
			        echo $list .='</select></td>';
		                exit;
		        }
		        else{
		                foreach($CitySlist as $s) {	
		                if($s->city_id != 0)
		                {
		                $list = '<td><label>'.$this->Lang["SEL_CITY"].'</label></td>
                                        <td><label>:</label></td>
                                        <td><select name="city">';
                                    
                                    }
                                }
		                foreach($CitySlist as $s){
			
			                $list .='<option value="'.$s->city_id.'">'.ucfirst($s->city_name).'</option>';
		                }
		                echo $list .='</select></td>';
		                exit;
		    }
		}
	}
	
	/** VIEW USER DETAILS**/
	
	public function view_user($user_id = "")
	{
		$this->manage_users = "1";
		$this->users_deatils = $this->users->get_user_view_data($user_id);
			if(count($this->users_deatils) == 0){
				common::message(-1, $this->Lang["NO_RECORD_FOUND"]);
				url::redirect(PATH."admin/manage-user.html");
			}
		$this->transaction_list = $this->users->get_transaction_data($user_id);
		$this->product_transaction_list = $this->users->get_transaction_product_data($user_id);
		$this->user_refrel_list= $this->users->user_refrel_list($user_id);
		$this->template->title = $this->Lang["USER_DET"];
		$this->template->content = new View("view_users");
	}
	
	/** DASHBOARD USER LIST**/	
	public function dashboard_users()
	{
		$this->dashboard_users = "1";
	    $this->template->javascript .= html::script(array(PATH.'js/jquery-1.5.1.min.js', PATH.'js/jquery-ui-1.8.11.custom.min.js', PATH.'js/jquery-ui-timepicker-addon.js'));	   
		$this->template->style .= html::stylesheet(array(PATH.'css/datetime.css'));
		$this->user_list = $this->users->get_user_list();
		$this->template->content = new View("users_dashboard");
		$this->template->title = $this->Lang['CUSTM_DASH'];
	}	
	
}
